#ifndef OP5_LICENSE_LUA_USERDATA_H_
#define OP5_LICENSE_LUA_USERDATA_H_

#include <lua.h>
#include <stdbool.h>

struct op5lic_query_env_udata_t {
	const struct op5lic_env_list_t *environment;
};

struct op5lic_query_response_udata_t {
	struct string_list_t *message_list;
	struct metric_list_t *metric_list;
};

/*
 * Create and registers response metatable
 */
int op5lic_query_luaregister_userdata_response(lua_State *L);

/*
 * Registers library functions
 */
int op5lic_query_luaregister_libfunctions(lua_State *L);

/*
 * Creates, initializes and pushes a new response userdata
 */
struct op5lic_query_response_udata_t * op5lic_query_response_udata_new(lua_State *L);

/*
 * Create and registers env metatable
 */
int op5lic_query_luaregister_userdata_env(lua_State *L);


/*
 * Creates, initializes and pushes a new env userdata
 */
struct op5lic_query_env_udata_t * op5lic_query_env_udata_new(lua_State *L,
		const struct op5lic_env_list_t *environment);


/*
 * Returns the determined value of the response `allow' value. This is *not* necessarily the same
 * as directly reading the value from the struct.
 */
bool op5lic_query_response_udata_allow(struct op5lic_query_response_udata_t *qresponse);
#endif
